; Copyright 2000, by Michael Vincent & Robin Kay. All rights reserved.
;
;
.nolist    
#include "tse.inc"
.list

.org    userMem-2
.db     $BB,$6D

start:

 ; --LOAD KERNAL--
 ; Look up the kernal in the symbol table
 ld hl, tsekrnl
 bcall(_mov9toop1)
 bcall(_chkfindsym)  

 ; Return if not found
 ret c
 ld a, b
 ex de, hl

 ; Get dest
 ld de, saferam1

 ; Get size
 ld bc, 768

 ; Handle if archived
 cp 0
 jr z, KrnlNotFlash

 ; Stream from Flash
 call streamFlash

 jr KrnlFlash
KrnlNotFlash:

 ; Copy
 call loadRAM

KrnlFlash:

 ; --LOAD LIBRARY--
 ; Delete stats
 bcall(_DelRes)

 ; Look up the library in the symbol table
 ld hl, tselibs
 bcall(_mov9toop1)
 bcall(_chkfindsym)

 ; Return if not found
 ret c
 ld a, b
 ex de, hl

 ; Get dest
 ld de, saferam2

 ; Get size
 ld bc, 531

 ; Handle if archived
 cp 0
 jr z, LibsNotFlash

 ; Stream from Flash
 call streamFlash

 jr LibsFlash
LibsNotFlash:

 ; Copy
 call loadRAM

LibsFlash:

 ; --EXEC KERNAL--
 ; Call kernal
 jp saferam1

; Routine to stream varibles from flash
streamFlash:
 push bc
 ld bc, 8 + name_length + 5
 add hl, bc
 pop bc
 bcall(_FlashToRam)
 ret

; Routine to load varibles from RAM
loadRAM:
 push de
 ld de, 5
 add hl, de ; Skip header + ret
 pop de
 ldir
 ret

; Libs and Kernal variable names
; Varible names MUST be the same length!!!
name_length .equ 9

tsekrnl:
.db ProtProgObj, "TSEKRNL",0
tselibs:
.db ProtProgObj, "TSELIBS",0

.end
